package de.hs_mannheim.informatik.spreadsheet;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class SpreadsheetTest {

    @Test
    void calculateTheSumOfNumbers(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "=13+6");
        assertEquals("19", eingabe.get("T5"));

        eingabe.put("T6", "=0+0");
        assertEquals("0", eingabe.get("T6"));

        eingabe.put("T7", "=22+34");
        assertEquals("56", eingabe.get("T7"));

        eingabe.put("T8", "= 9 + 3");
        assertEquals("12", eingabe.get("T8"));
    }

    @Test
    void calculateTheDifOfNumbers(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "=13-6");
        assertEquals("7", eingabe.get("T5"));

        eingabe.put("T6", "=0-0");
        assertEquals("0", eingabe.get("T6"));

        eingabe.put("T7", "=22-34");
        assertEquals("-12", eingabe.get("T7"));

        eingabe.put("T8", "= 9 - 3");
        assertEquals("6", eingabe.get("T8"));
    }

    @Test
    void calculateTheProdOfNumbers(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "=13*6");
        assertEquals("78", eingabe.get("T5"));

        eingabe.put("T6", "=0*0");
        assertEquals("0", eingabe.get("T6"));

        eingabe.put("T7", "=-2*34");
        assertEquals("-68", eingabe.get("T7"));

        eingabe.put("T8", "= 9 * 3");
        assertEquals("27", eingabe.get("T8"));
    }

    @Test
    void calculateTheValueOfQuotOfNumbers(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "=12/3");
        assertEquals("4", eingabe.get("T5"));

        eingabe.put("T6", "=5/0");
        assertEquals("exc.", eingabe.get("T6"));

        eingabe.put("T7", "= 22 / 2");
        assertEquals("11", eingabe.get("T7"));

        eingabe.put("T8", "= 0 / 5");
        assertEquals("0", eingabe.get("T8"));
    }
    @Test
    void calculateTheSumOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "8");
        eingabe.put("T6", "2");
        eingabe.put("T7", "30");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=Summe(T5:T8)");
        assertEquals("50", eingabe.get("T9"));
    }

    void calculateTheSProdOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "2");
        eingabe.put("T6", "4");
        eingabe.put("T7", "6");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=Produkt(T5:T8)");
        assertEquals("480", eingabe.get("T9"));
    }
    void calculateTheMitOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "8");
        eingabe.put("T6", "2");
        eingabe.put("T7", "30");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=Mittelwert(T5:T8)");
        assertEquals("12", eingabe.get("T9"));
    }
    void calculateTheStabwOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "8");
        eingabe.put("T6", "2");
        eingabe.put("T7", "30");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=Stabw(T5:T8)");
        assertEquals("12", eingabe.get("T9"));
    }
    void calculateTheMinOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "8");
        eingabe.put("T6", "2");
        eingabe.put("T7", "30");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=min(T5:T8)");
        assertEquals("2", eingabe.get("T9"));
    }
    void calculateTheMaxOfRectangular(){
        Spreadsheet eingabe = new Spreadsheet(99, 26);

        eingabe.put("T5", "8");
        eingabe.put("T6", "2");
        eingabe.put("T7", "30");
        eingabe.put("T8", "10");
        eingabe.put("T9", "=Summe(T5:T8)");
        assertEquals("30", eingabe.get("T9"));
    }
}